# hexo-prism-plus

[![npm version](https://badge.fury.io/js/hexo-prism-plus.svg)](https://badge.fury.io/js/hexo-prism-plus)
[![npm dependencies](https://david-dm.org/Aetf/hexo-prism-plus.svg)](https://david-dm.org/Aetf/hexo-prism-plus)
[![Build Status](https://github.com/Aetf/hexo-prism-plus/workflows/Node.js%20CI/badge.svg)](https://github.com/Aetf/hexo-prism-plus/actions?query=workflow%3A"Node.js+CI")

[![NPM](https://nodei.co/npm/hexo-prism-plus.png)](https://npmjs.org/package/hexo-prism-plus)

Better code block highlighting with [Prism](http://prismjs.com/index.html) for [Hexo](https://hexo.io).

## Features

- Exposes the full power of Prism with an elegent interface in markdown.
    * Control classes, styles and data attributed on generated elements.
    * Use presets to manage different use cases with ease.
- Full server-side rendering supporting **most** Prism plugins.
    * Unlike other Prism SSR solutions which breaks most plugins, `hexo-prism-plus` uses `jsdom`
    to render the full HTML markup and then uses a clever client-side hydration to reattach event
    handlers, so most plugins works normally.
    * Simply set desired Prism plugin names in the config, `hexo-prism-plus` takes care of the rest.
- Additional tag plugin similar to the original `include_code` tag, but with all enhanced features.

## Demo

All code blocks in [my blog](https://unlimited-code.works) are generated by this plugin. Please go and take a look.
The source code is available on [Github](https://github.com/Aetf/Aetf.github.io).

## Installation

`npm i -S hexo-prism-plus`

This will install `hexo-prism-plus` and add it as a dependency in your `package.json`.

The default highlight is automatically disabled, so no more change is needed.

Note: this plugin uses server-side rendering combined with client-side hydration, and thus it
ships with its own copy of prismjs. Make sure you disable any other prismjs related config in your
theme to avoid conflicts.

## Usage

See [wiki](https://github.com/Aetf/hexo-prism-plus/wiki/Config-Options) for detailed description for both inline options and site options.

### Backtick Code Block

Just write code using fenced code block syntax as usual.
Additional options for Prism can be specified either inline or using a preset defined inside the site config file `_config.yml`.

    ```python preset=mypreset lineno=True line=1-4,7
    # some code
    ```


### Tag Plugin

To insert code snippets from file with Prism highlight, use

```
{% includecode /path/to/file [inline options] %}
```

`/path/to/file` is relative to `code_dir` in `_config.yml`.
And inline options take the same format as those used in backtick code blocks.
